var boardObserver = {

  id : '',
  showMenuPopupTimer : null,
  hideMenuPopupTimer : null,
  aTarget : null,
  
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("application/x-moz-url");
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
	onDragCloseMenu : function (node) {
    var children = node.childNodes;
    for (var i = 0; i < children.length; i++) {
      if (children[i].id.indexOf('m_') > -1) {
        this.onDragCloseMenu(children[i].firstChild);
        children[i].firstChild.hidePopup();
      }
    }
		node.hidePopup();	
	},
	onDragStart: function (evt, transferData){    
		var url = evt.target.getAttribute('gbb-url');
		var title = evt.target.getAttribute('label');
		this.id = evt.target.getAttribute('id')
		data = url+"\n"+title;
	  transferData.data = new TransferData();
	  transferData.data.addDataForFlavour("text/unicode",data);
	},
	onDragOver: function (evt,session) {				
	 	var now = new Date().getTime();
	  target = evt.target;
		switch (target.nodeName) {    
	    case "toolbarbutton":
				if (this.showMenuPopupTimer && now - 350 > this.showMenuPopupTimer){
						this.aTarget.firstChild.showPopup();
						this.showMenuPopupTimer = null;	
						document.getElementById('GBB_bookmark_menupopup').showPopup(); }
	    	else{	}
				break;
	    case "menu":
				if (this.showMenuPopupTimer && now - 350 > this.showMenuPopupTimer){
					var menuitems = evt.target.parentNode.childNodes;
	        for (var i=0; i < menuitems.length; i++) {
	          var mi = menuitems[i];
	          if(mi.id.indexOf('m_') > -1)
	            if (mi.id != target.id){
	              try { this.onDragCloseMenu(mi.firstChild); }
	              catch(e) { dumpDebug('*'); }
							}}
						this.aTarget.firstChild.showPopup();
	    			this.showMenuPopupTimer = null; }
	    	else{	}
	    	break;
	    case "menuitem":
				if (this.showMenuPopupTimer && now - 350 > this.showMenuPopupTimer) {
					dumpDebug("yes\n");
					var menuitems = evt.target.parentNode.childNodes;
	        for (var i=0; i < menuitems.length; i++) {
	          var mi = menuitems[i];
	          if(mi.id.indexOf('m_') > -1)
	            if (mi.id != target.id){
	              try { this.onDragCloseMenu(mi.firstChild); }
	              catch(e) { dumpDebug('!'); }
							}}
	    			this.showMenuPopupTimer = null; }
	    	else{	dumpDebug("no\n"); }
	    	break;
		}
	},
	onDragEnter: function (evt,session){
	  target = evt.target;
	  switch (target.nodeName) {    
	    case "toolbarbutton":
				var now = new Date().getTime();
				this.showMenuPopupTimer = now;
				this.aTarget = target;
	  		//document.getElementById('GBB_add_to_new_folder').style.display = 'block';        
	      break;
	    case "menu":
	  		//document.getElementById('GBB_add_to_new_folder').style.display = 'block';        
	      //target.style.borderBottom = "1px solid #000000";
				var menuitems = document.getElementById('GBB_bookmark_menupopup').childNodes;
				var now = new Date().getTime();
				this.showMenuPopupTimer = now;
				this.aTarget = target;
				break;
	    case "menuitem":
	  		//document.getElementById('GBB_add_to_new_folder').style.display = 'block';              
	    	if (target.parentNode.id == "GBB_bookmark_menupopup") {
					var now = new Date().getTime();
					this.showMenuPopupTimer = now;
					this.aTarget = target; }		
				break;
	    default:
				window.dump("in: "+target.nodeName+"\n");
	  }
	},
	onDragExit: function (evt) {    
	  target = evt.target;
	  switch (target.nodeName) {    
	    case "menu": {      	
				//target.firstChild.hidePopup();
	      break; }
	  }
	}, 
	onDrop: function (evt,dropdata){
		if (dropdata.data != "") {
	    target = evt.target;
	    var data = dropdata.data.split("\n");    
			var notes = gbb_BookmarkArray.getBookmarkById(this.id).notes;
	    if (data[1]) {
	      switch (target.nodeName) {    
	        case "toolbarbutton": {
	          if (evt.ctrlKey)
	            GBB.GBB_onAddBookmark(data[1], data[0]);
	          else
	            GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], '', notes);
	          break; }
	        case "menuitem": {
	          var labels = '';
	           if (target.id == 'GBB_add_to_new_folder') {
								newLabelDialog = new GBB_newLabelDialog();
						    newLabelDialog.onOpen(data[0], data[1]); }
						 else if(target.parentNode.id.indexOf('mp_') > -1) {   
							labels = target.parentNode.parentNode.getAttribute('gbb-label');//id.substr(3,target.parentNode.id.length)
	            if (evt.ctrlKey)
	            	GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], labels+','+gbb_BookmarkArray.getLabelsByUrl(data[0]), notes);
							else
	            	GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], labels);
	            target.parentNode.hidePopup(); }
						else {
	            	GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], '', notes); }
	          break; }
	        case "menu": {
	          var labels = '';             
	          if(target.id.indexOf('m_') > -1) {
	            labels = target.getAttribute('gbb-label');//id.substr(2,target.id.length)
	            if (evt.ctrlKey)
	            	GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], labels+','+gbb_BookmarkArray.getLabelsByUrl(data[0]), notes);
							else
	              GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], labels, notes);                
	            target.parentNode.hidePopup(); }
						else 
							GBB.GBB_onQuickAddBookmark(evt, data[1], data[0], '', notes);
	          break; }                       
	      }
	    }
	    closeMenus(target); }
  }
};
