var gbbPrefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gbb.");
                            
var gbbSettings = {
	onLoad: function() {
 	    this.orderby = document.getElementById("orderby");
	    this.orderby.value = gbbPrefs.getCharPref("orderby");	

 	    this.enableExperimentalFeatures = document.getElementById("enableExperimentalFeatures");
	    this.enableExperimentalFeatures.checked = gbbPrefs.getBoolPref("enableExperimentalFeatures");	
			if (this.enableExperimentalFeatures.checked)
			 	window.document.getElementById('test').style.display=''; 
			else
				window.document.getElementById('test').style.display='none'; 	
			sizeToContent();

 	    this.labelHierarchySeparator = document.getElementById("labelHierarchySeparator");
	    this.labelHierarchySeparator.value = gbbPrefs.getCharPref("labelHierarchySeparator");	

			this.enableFavicons = document.getElementById("enableFavicons");
	    this.enableFavicons.checked = gbbPrefs.getBoolPref("enableFavicons");	

			this.enableFavicons = document.getElementById("enableLabelHierarchy");
	    this.enableFavicons.checked = gbbPrefs.getBoolPref("enableLabelHierarchy");	
	    window.document.getElementById('labelHierarchySeparator').disabled = !this.enableFavicons.checked;

	},

	onAccept: function() {
	   this.orderby = document.getElementById("orderby").value;
	   this.enableExperimentalFeatures = document.getElementById("enableExperimentalFeatures").checked;
	   this.labelHierarchySeparator = document.getElementById("labelHierarchySeparator").value;
		 this.enableFavicons = document.getElementById("enableFavicons").checked;
		 this.enableLabelHierarchy = document.getElementById("enableLabelHierarchy").checked;
				   
	   gbbPrefs.setCharPref("orderby",this.orderby);
	   gbbPrefs.setBoolPref("enableExperimentalFeatures",this.enableExperimentalFeatures);
	   gbbPrefs.setCharPref("labelHierarchySeparator",this.labelHierarchySeparator);
	   gbbPrefs.setBoolPref("enableFavicons",this.enableFavicons);
	   gbbPrefs.setBoolPref("enableLabelHierarchy",this.enableLabelHierarchy);

     Components.classes["@mozilla.org/preferences-service;1"].
        	getService(Components.interfaces.nsIPrefService).savePrefFile(null); 
	},

	onCancel: function() {},
}
