function inArray (array, value) {
	var i;
	for (i=0; i < array.length; i++) {
		if (array[i] === value) {
			return true;
		}
	}
	return false;
};

function gbb_Bookmark (id, url, title, labels, notes) {
 	this.id = id;
 	this.url = url;
 	this.title = title;
 	this.labels = labels;
 	this.notes = notes;
}

function BookmarkArray() {}

BookmarkArray.prototype = [];

BookmarkArray.prototype.getBookmarkById = function(id){
	var i;
  for (i=0; i < this.length; i++) 
  	if (this[i].id == id)
			return this[i];
  return false;	}

BookmarkArray.prototype.getBookmarksByLabel = function(label) {
	var i, j;
	var ret = new Array();
	var label = label;
  for (i=0; i < this.length; i++) 
    for (j=0; j < this[i].labels.length; j++) 
		  if (this[i].labels[j] == label)
			  ret.push(this[i]);
  return ret;}

BookmarkArray.prototype.getLabelsByUrl = function(url, f) {
	var i;
	var func = f ? f : function(a) { ret = a; } 	
	ret = new Array;
  for (i=0; i < this.length; i++)
	  if (this[i].url == url)
			func(this[i].labels);
  return ret;}
  
BookmarkArray.prototype.getNotesByUrl = function(url) {
	var i;
	var ret = '';
  for (i=0; i < this.length; i++)
	  if (this[i].url == url)
			ret = this[i].notes;
  return ret;}

BookmarkArray.prototype.getLabels = function(str, f) {
	var i, j;
	var func = f ? f : function(a) { ret.push(a); } 
  var str = str ? str : '';
	ret = new Array();
  for (i=0; i < this.length; i++) 
    for (j=0; j < this[i].labels.length; j++) 
		  if (this[i].labels[j].indexOf('^') == -1 && !inArray(ret, this[i].labels[j])) {
			 var aux_str = this[i].labels[j].toUpperCase();
			 if (aux_str.indexOf(str.toUpperCase()) == 0)
			 		func(this[i].labels[j]);
			}
	function sortstr(a,b) {
	    aa = a.toLowerCase();
	    bb = b.toLowerCase();
	    if (aa==bb) return 0;
	    if (aa<bb) return -1;
	    return 1;
	}		
  return ret.sort(sortstr);}

BookmarkArray.prototype.isBookmarked = function(url) {
	var i;
  for (i=0; i < this.length; i++) 
		if (this[i].url == url)
    	return this[i].id;
  return false;}

BookmarkArray.prototype.renameLabel = function(label, newlabel) {
	var i, j;
	var label = label;
  for (i=0; i < this.length; i++) 
    for (j=0; j < this[i].labels.length; j++) 
		  if (this[i].labels[j] == label)
		  	if (newlabel == '')
			  	this[i].labels.splice(j, 1);
		  	else
			  	this[i].labels[j] = newlabel;
	}
