// Popup: http://www.google.com/bookmarks/mark?output=popup&bkmk={URL}&title={TITULO}&labels={ETIQUETAS SEPARADAS POR COMAS}&annotation={NOTAS}&q=is:bookmarked&btnA=Save&s=c93LAhmgsTmfnyWR5BJxNg				
// Bookmark: http://www.google.com/bookmarks/mark?q={URL}&title={TITULO}&{ETIQUETAS SEPARADAS POR COMAS}&annotation={NOTAS}&sig={KEY}
// Unbookmark: http://www.google.com/bookmarks/mark?dlq={IDENTIFICADOR}&sig={KEY}
 
var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
                        .getService(Components.interfaces.nsICookieManager);

var gbb_menu_isset = false;
var gbb_dom = null;
var gbb_isSigned = false;
var req;
var addBookmarkDialog;
var renameLabelDialog;
var newLabelDialog;
var GBB_refreshInterval = null;
//var gbb_BookmarkArray;

function dumpDebug(str) {
	var enableWindowDump = GBB.gbbPrefs.getBoolPref("enableWindowDump");
	if (enableWindowDump)
		window.dump(str);
}

// XXX This code was taken from http://www.worldtimzone.com/res/encode/
function utf8(wide) {
  var c, s;
  var enc = "";
  var i = 0;
  while(i<wide.length) {
    c= wide.charCodeAt(i++);
    // handle UTF-16 surrogates
    if (c>=0xDC00 && c<0xE000) continue;
    if (c>=0xD800 && c<0xDC00) {
      if (i>=wide.length) continue;
      s= wide.charCodeAt(i++);
      if (s<0xDC00 || c>=0xDE00) continue;
      c= ((c-0xD800)<<10)+(s-0xDC00)+0x10000;
    }
    // output value
    if (c<0x80) enc += String.fromCharCode(c);
    else if (c<0x800) enc += String.fromCharCode(0xC0+(c>>6),0x80+(c&0x3F));
    else if (c<0x10000) enc += String.fromCharCode(0xE0+(c>>12),0x80+(c>>6&0x3F),0x80+(c&0x3F));
    else enc += String.fromCharCode(0xF0+(c>>18),0x80+(c>>12&0x3F),0x80+(c>>6&0x3F),0x80+(c&0x3F));
  }
  return enc;
}

function unescapeHTML(s) {
	if (s) {
		s = s.replace(/&quot;/g, "\"");
		s = s.replace(/&amp;/g, "&");	
		s = s.replace(/&#39;/g, "'");
		s = s.replace(/&lt;/g, "<");
		s = s.replace(/&gt;/g, ">");	
	}
	return s; }

function escapeHTML(s) {
	s = s.replace(/\\/g, "&quot;");
	s = s.replace(/&/g, "&amp;");	
	s = s.replace(/\'/g, "&#39;");
	s = s.replace(/</g, "&lt;");
	s = s.replace(/>/g, "&gt;");	
	return s; }
	
function GBB_checkSignedCookie() {
  var i = cookieManager.enumerator;
	//dumpDebug("Checking cookie... ") 

  while (i.hasMoreElements()){
    var cookie = i.getNext();
    if (cookie instanceof Components.interfaces.nsICookie){
      if (cookie.host == ".google.com")
      	if (cookie.name == "SID") {
      		//dumpDebug("signed in\n") 
        	return true;
        }
    }
  }
	//dumpDebug("not signed in\n")  
  return false;
}

function faviconURIChecker (img, id) {
	this.img = img;
	this.id = id;
}

faviconURIChecker.prototype = {
	onStartRequest: function(request, context) {},
	onStopRequest: function(request, context, status) {
		var GBB_item = document.getElementById(this.id);
		if (status == 0 && GBB_item) {
			GBB_item.setAttribute('image', this.img.spec);	   					  							
		}
	}	
}

var GBB = {
	gbbPrefs : null,
	locale_strings : null, 
	oldUserAgent : null,
	
	GBB_onLoad : function() {
			this.locale_strings = document.getElementById('gbb_locale_strings');
			this.gbbPrefs = Components.classes["@mozilla.org/preferences-service;1"].
			                          getService(Components.interfaces.nsIPrefService).getBranch("gbb.");
			this.gbbPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
      this.gbbPrefs.addObserver('', this, false);
      
			if (!this.gbbPrefs.prefHasUserValue("orderby")) this.gbbPrefs.setCharPref("orderby", "date");
			if (!this.gbbPrefs.prefHasUserValue("enableExperimentalFeatures")) this.gbbPrefs.setBoolPref("enableExperimentalFeatures", false);
			if (!this.gbbPrefs.prefHasUserValue("labelHierarchySeparator")) this.gbbPrefs.setCharPref("labelHierarchySeparator","/");
			if (!this.gbbPrefs.prefHasUserValue("enableWindowDump")) this.gbbPrefs.setBoolPref("enableWindowDump", false);
			if (!this.gbbPrefs.prefHasUserValue("refreshIntervalMinutes")) this.gbbPrefs.setIntPref("refreshIntervalMinutes", 10);
			if (!this.gbbPrefs.prefHasUserValue("enableFavicons")) this.gbbPrefs.setBoolPref("enableFavicons", false);
			if (!this.gbbPrefs.prefHasUserValue("enableLabelHierarchy")) this.gbbPrefs.setBoolPref("enableLabelHierarchy", false);
			      
   	  document.getElementById('contentAreaContextMenu').addEventListener('popupshowing', function(e) { GBB.GBB_onContextMenuShowing() }, false);
    
      document.getElementById('GBB_bookmark_menupopup').setAttribute('gbb-hidden', 'true'); 
			this.GBB_getBookmarksFeed();

	  	var gbb_tabbox = getBrowser().mTabBox;
	    gbb_tabbox.addEventListener("load", this.GBB_checkIfPageIsBookmarked, true);
	    gbb_tabbox.addEventListener("select", this.GBB_checkIfPageIsBookmarked, true);
	    gbb_tabbox.addEventListener("pageshow", this.GBB_checkIfPageIsBookmarked, true);

			// Sets an interval (defined by refreshIntervalMinutes) for refreshing the feed
			var refreshIntervalMinutes = this.gbbPrefs.getIntPref("refreshIntervalMinutes");
			if (refreshIntervalMinutes < 5) refreshIntervalMinutes = 5;
	  	GBB_refreshInterval = window.setTimeout('GBB.GBB_onRefresh()', refreshIntervalMinutes*60000);	 

		  // Here we localize the description on startup  
			var GBB_LocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].
			 		getService(Components.interfaces.nsIPrefService).getBranch("extensions.{0dad0080-ca5a-11da-a94d-0800200c9a66}.");			 		

		  var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString ); 
			str.data = this.locale_strings.getString('GBB_description');
		  GBB_LocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );  
	},


  observe : function (subject, topic, data) {
     if (topic != "nsPref:changed")
       return;
		 this.GBB_onRefresh(false);
	},

	GBB_onContextMenuShowing : function (e) {
		  var popupnode = document.popupNode;
			var nodeLocalName = popupnode.localName.toLowerCase();
			dumpDebug(nodeLocalName+"\n");
			if (nodeLocalName != "a") {	
				document.getElementById('contextGBBbookmarkpage').hidden = true;
			}else{
				document.getElementById('contextGBBbookmarkpage').hidden = false;	
			}
	},
	
	GBB_getBookmarksFeed : function () {
		gbb_isSigned = GBB_checkSignedCookie();
		if (!gbb_dom && gbb_isSigned && !req)	{
			req = new XMLHttpRequest();
		  var orderby = this.gbbPrefs.getCharPref("orderby");
			/* Since Bookmark annotations are only in the RSS feed and not in the XML one,
			   and Bookmark IDs are only in the XML feed I need to get the two files 
				 and merge them into one big bookmark array with all the data.
			   Dear Google guys, please add annotations to the XML feed or IDs to the RSS one
			*/		   
			req.open("GET", "http://www.google.com/bookmarks/lookup?output=xml&num=10000", true); 
			req.send(null);
			dumpDebug("XML: Connecting... \n");
			req.onerror = function(ev) { dumpDebug("Error!\n"); }
			req.onreadystatechange = function(ev) {
				dumpDebug("XML: Status: "+req.readyState+"\n");
				if(req.readyState == 4) {
					var status = -1;
					try { status = req.status }
					catch(e) { dumpDebug(e+"\n"); }
					if(status == 200) {
						dumpDebug("XML: Connection worked! ("+req.status+")\n")
						if (gbb_dom = req.responseXML) {
      	  		var gbb_items = gbb_dom.documentElement.getElementsByTagName('bookmark');	 		    
      	  		for (var i = 0; i < gbb_items.length; i++) {  
                  var gbb_auxBookmark = new gbb_Bookmark();
  				        gbb_auxBookmark.labels = [];                      
                  gbb_auxBookmark.id = gbb_items[i].getElementsByTagName('id')[0].childNodes[0].nodeValue;			
                  gbb_auxBookmark.url = gbb_items[i].getElementsByTagName('url')[0].childNodes[0].nodeValue;
                  gbb_auxBookmark.title = gbb_items[i].getElementsByTagName('title')[0] ? gbb_items[i].getElementsByTagName('title')[0].childNodes[0].nodeValue : gbb_auxBookmark.url; 	  				    
                  //gbb_auxBookmark.notes = '';
									var auxLabelsArray = gbb_items[i].getElementsByTagName('label');
          	  		for (var j = 0; j < auxLabelsArray.length; j++)
                      if (auxLabelsArray[j].childNodes[0].nodeValue.indexOf('^') == -1){
                      	//dumpDebug("Adding label '"+auxLabelsArray[j].childNodes[0].nodeValue+"' to '"+gbb_auxBookmark.title+"'\n");
                        gbb_auxBookmark.labels.push(auxLabelsArray[j].childNodes[0].nodeValue);}
                  gbb_BookmarkArray.push(gbb_auxBookmark);
  							} 
								req.open("GET", "http://www.google.com/bookmarks/lookup?output=rss&num=10000", true); 
								req.send(null);						
								dumpDebug("RSS: Connecting... \n");
								req.onreadystatechange = function(ev) {
									dumpDebug("RSS: Status: "+req.readyState+"\n");
									if(req.readyState == 4) {
										var status = -1;
										try { status = req.status }
										catch(e) { dumpDebug(e); }
										if(status == 200) {
											dumpDebug("RSS: Connection worked! ("+req.status+")\n")
											if (gbb_dom2 = req.responseXML) {
												var gbb_items = gbb_dom2.documentElement.getElementsByTagName('item');	  
												for (var i = 0; i < gbb_items.length; i++) {
													try { gbb_BookmarkArray[i].notes = gbb_items[i].getElementsByTagName('bkmk_annotation')[0].childNodes[0].nodeValue; }
													catch(e){ gbb_BookmarkArray[i].notes = ''; };
												}
												GBB.GBB_generateBookmarkMenuPopup();
												GBB.GBB_checkIfPageIsBookmarked();
												GBB.GBB_writeTagsOnFile();
											}else{
												dumpDebug("RSS: Error while getting the bookmark feed\n"); }
										}else{
											dumpDebug("RSS: Connection with the server failed ("+req.status+")\n"); }
									}
								}  						
						}else{
							dumpDebug("XML: Error while getting the bookmark feed\n");
						}
					}else{
						dumpDebug("XML: Connection with the server failed ("+req.status+")\n")
					}
				}
			}
		}
	},
	
	GBB_writeTagsOnFile: function() {
		fileFlags = {
			// From http://lxr.mozilla.org/mozilla/source/nsprpub/pr/include/prio.h#600
			RDONLY: 0x01,
			WRONLY: 0x02,
			RDWR: 0x04,
			CREATE_FILE: 0x08,
			APPEND: 0x10,
			TRUNCATE: 0x20,
			SYNC: 0x40,
			EXCL: 0x80
		};
		
		fileMode = 0660;

		const id = "{0dad0080-ca5a-11da-a94d-0800200c9a66}";
		var labelsFile = Components.classes["@mozilla.org/extensions/manager;1"]
		                    .getService(Components.interfaces.nsIExtensionManager)
		                    .getInstallLocation(id)
		                    .getItemLocation(id); 
		labelsFile.append('chrome');
		labelsFile.append('content');
		labelsFile.append('google-bookmarks-button');
		labelsFile.append('tags.dat');
    if (!labelsFile.exists())
      labelsFile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, fileMode);
		
		var aLocalStream = Components.classes['@mozilla.org/network/file-output-stream;1'].
													createInstance(Components.interfaces.nsIFileOutputStream);
		aLocalStream.init(labelsFile, fileFlags.WRONLY | fileFlags.CREATE_FILE | fileFlags.TRUNCATE, fileMode, 0);
		var output = new String(gbb_BookmarkArray.getLabels(''));
		aLocalStream.write(output, output.length);
		aLocalStream.close();	
	},
	
	GBB_onRefresh : function(getDataFeed) {
		var getDataFeed = getDataFeed != null ? getDataFeed : true;
		var bookmarkMenuPopup = document.getElementById('GBB_bookmark_menupopup');
		var separator = null;
		bookmarkMenuPopup.hidePopup();
		dumpDebug("Refresh!\n");		
		if (separator = document.getElementById('GBB_menu_separator')) {
	  	var aux = separator.nextSibling; 
	  	while (aux.id != 'GBB_menu_separator_end') {
	  		bookmarkMenuPopup.removeChild(aux);
	  		aux = separator.nextSibling; }	  
	    bookmarkMenuPopup.removeChild(document.getElementById('GBB_menu_separator'));
	    bookmarkMenuPopup.removeChild(document.getElementById('GBB_menu_separator_end'));
	  }	    
		gbb_menu_isset = false;
		if (getDataFeed) {		
		  gbb_BookmarkArray = new BookmarkArray();
			gbb_dom = null;
			gbb_dom2 = null;
			req = null;
			var refreshIntervalMinutes = this.gbbPrefs.getIntPref("refreshIntervalMinutes");	
			if (refreshIntervalMinutes < 5) refreshIntervalMinutes = 5;
	  	window.clearTimeout(GBB_refreshInterval);
	  	GBB_refreshInterval = window.setTimeout('GBB.GBB_onRefresh()', refreshIntervalMinutes*60000);
			GBB.GBB_getBookmarksFeed();	
		}else{
			GBB.GBB_generateBookmarkMenuPopup();
		}
	},

	GBB_checkIfPageIsBookmarked : function(event)	{
		if (window.content.location.href == 'http://toolbar.google.com/command?close_browser')
			window.close(); 
		var bookmarkButton = document.getElementById('GBB_bookmark_button');
		var bookmarkThisPageMenu = document.getElementById('GBB_bookmark_this_page')
		var removeThisBookmarkMenu = document.getElementById('GBB_remove_bookmark');
		var bookmarkId;
		//if (event) dumpDebug("Event: "+event.type+"\n");
		if (gbb_isSigned != GBB_checkSignedCookie()) GBB.GBB_onRefresh();
	  if (gbb_isSigned) {
			theUrl = window.content.location.href;    
  		if (bookmarkId = gbb_BookmarkArray.isBookmarked(theUrl)) {
  			//dumpDebug("Is a bookmark\n");
  			bookmarkButton.setAttribute('image', 'chrome://google-bookmarks-button/skin/book_on.gif');
  			bookmarkButton.setAttribute('tooltiptext', GBB.locale_strings.getString('GBB_bookmark_button_remove.label'));
  			bookmarkThisPageMenu.setAttribute('label', GBB.locale_strings.getString('GBB_bookmark_button_edit.label'));
  			bookmarkThisPageMenu.setAttribute('tooltiptext', GBB.locale_strings.getString('GBB_bookmark_button_edit.tooltip'));
				removeThisBookmarkMenu.style.display = 'block';
				removeThisBookmarkMenu.setAttribute('oncommand', 'GBB.GBB_onRemoveBookmark("'+bookmarkId+'")'); }
			else {
  			//dumpDebug("Is not a bookmark\n");
  			bookmarkButton.setAttribute('image', 'chrome://google-bookmarks-button/skin/book_off.gif');	
  			bookmarkButton.setAttribute('tooltiptext', GBB.locale_strings.getString('GBB_bookmark_button.tooltip'));  			
  			bookmarkThisPageMenu.setAttribute('label', GBB.locale_strings.getString('GBB_bookmark_button.label'));
  			bookmarkThisPageMenu.setAttribute('tooltiptext', GBB.locale_strings.getString('GBB_bookmark_button.tooltip'));
				removeThisBookmarkMenu.style.display = 'none'; } 
		}else{
			bookmarkButton.setAttribute('image', 'chrome://google-bookmarks-button/skin/book_off.gif');	
			bookmarkButton.setAttribute('tooltiptext', GBB.locale_strings.getString('GBB_bookmark_button.tooltip'));  					
		}
	},

  GBB_onStarClicked : function(e) {
  	var bookmarkId;
  	var theUrl = window.content.location.href;
		var selectedText = window.content.getSelection().toString();
		if (!gbb_isSigned)
      GBB.GBB_onSignIn(e);
    else if (e.ctrlKey)
    	if (bookmarkId = gbb_BookmarkArray.isBookmarked(theUrl))
    		GBB.GBB_onEditBookmark(e, bookmarkId);
    	else
      	GBB.GBB_onAddBookmark('', theUrl, selectedText);
		else if (bookmarkId = gbb_BookmarkArray.isBookmarked(theUrl))
		  GBB.GBB_onRemoveBookmark(bookmarkId);
    else
      GBB.GBB_onQuickAddBookmark(e, '', '', '', selectedText); },
  	

	GBB_onLinkContext : function(e) {
		var bookmarkId;
		var url = 'getLinkURL' in gContextMenu ? gContextMenu.getLinkURL() : gContextMenu.linkURL();
		var title = gContextMenu.linkText();
		if (!gbb_isSigned)
       GBB.GBB_onSignIn(e);
		else if (bookmarkId = gbb_BookmarkArray.isBookmarked(url))
       GBB.GBB_onEditBookmark(e, bookmarkId);
		else
       GBB.GBB_onAddBookmark(title, url);
	},

	GBB_onAddBookmark : function(title, url, notes) {
    var theUrl = url ? url : window.content.location.href;
		var docTitle = title ? title : window.content.document.title;
		var notes = notes ? notes : '';
    document.getElementById('GBB_bookmark_menupopup').hidePopup();
		addBookmarkDialog = new GBB_addBookmarkDialog('add', theUrl, docTitle, notes);
    addBookmarkDialog.onOpen(theUrl, docTitle);
	},

  GBB_OverrideUserAgent : function(){
    var httpHandler=Cc["@mozilla.org/network/protocol;1?name=http"].getService(Ci.nsIHttpProtocolHandler)
    var userAgent=httpHandler.userAgent
    var prefs=Components.classes["@mozilla.org/preferences-service;1"].
			        getService(Components.interfaces.nsIPrefService).getBranch("general.useragent.");

    if(prefs.prefHasUserValue("override")) {
      this.oldUserAgent=prefs.getCharPref("override");
    }else{
      this.oldUserAgent=null;
    }   
    prefs.setCharPref("override",this.userAgent+' GoogleToolbarBB');
  },
  
  GBB_RestoreUserAgent : function(){
    var prefs=Components.classes["@mozilla.org/preferences-service;1"].
			        getService(Components.interfaces.nsIPrefService).getBranch("general.useragent.");
    if(this.oldUserAgent!=null)
      prefs.setCharPref("override",this.oldUserAgent);
    else 
      prefs.clearUserPref("override");
  },

 	GBB_onQuickAddBookmark : function(event, title, url, labels, notes) {
    GBB.GBB_OverrideUserAgent();
    var theUrl = url ? url : window.content.location.href;
		var docTitle = title ? title : window.content.document.title;	
		var labels = labels ? labels : '';	
		var notes = notes ? notes : '';	
  	var req = new XMLHttpRequest();
    req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
		req.send('q='+encodeURIComponent(theUrl)+'&title='+encodeURIComponent(docTitle)+'&labels='+labels+'&annotation='+encodeURIComponent(notes)+'&zx='+Math.floor(Math.random()*32768)); 
		// Asyncronous connection with the Google Bookmarks server
		dumpDebug("Sending request to add bookmark... \n");
		req.onreadystatechange = function(ev)	{
			dumpDebug("Status: "+req.readyState+"\n");
			if(req.readyState == 4) {
				var status = -1;
				try {	status = req.status }
				catch(e) { alert(e); }
				if(status == 200) {
					dumpDebug("Bookmark added! ("+req.status+")\n")
			    GBB.GBB_onRefresh(); }
				else{
          alert("An error occurred while adding the bookmark"); }
      }
    }
    GBB.GBB_RestoreUserAgent()
   },

	GBB_onEditBookmark : function(event, id) {
		var bookmark = gbb_BookmarkArray.getBookmarkById(id)
		
		var target = event.target;

    document.getElementById('GBB_bookmark_menupopup').hidePopup();
    addBookmarkDialog = new GBB_addBookmarkDialog('edit', bookmark.url, bookmark.title, bookmark.notes);
    addBookmarkDialog.onOpen(bookmark.url, bookmark.title);
	},

	GBB_onRemoveBookmark : function(id) {		
    document.getElementById('GBB_bookmark_menupopup').hidePopup();
		// XXX String not localized
    if(!confirm(this.locale_strings.getString('GBB_bookmark_remove_bookmark.confirm_box.before')+" \""+ gbb_BookmarkArray.getBookmarkById(id).title +"\""+this.locale_strings.getString('GBB_bookmark_remove_bookmark.confirm_box.after')))
  	  return; 	  
    GBB.GBB_OverrideUserAgent();
  	var req = new XMLHttpRequest();
 		// Asyncronous connection with the Google Bookmarks server
 		req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
 		req.send('dlq='+id);
		dumpDebug("Sending request to remove bookmark... \n");
		req.onreadystatechange = function(ev) {
			dumpDebug("Status: "+req.readyState+"\n");
			if(req.readyState == 4) {
				var status = -1;
				try {	status = req.status }
				catch(e) { alert(e); }
				if(status == 200) {
					dumpDebug("Bookmark removed! ("+req.status+")\n")
			    GBB.GBB_onRefresh(); }
				else {
          alert("An error occurred while removing the bookmark"); }
      }
    }	      
    GBB.GBB_RestoreUserAgent()    
    GBB.GBB_onRefresh();
	},
	
	GBB_onOpenRenameLabelDialog : function (label, event) {
    document.getElementById('GBB_bookmark_menupopup').hidePopup();
    renameLabelDialog = new GBB_renameLabelDialog();
    renameLabelDialog.onOpen(label);
	},

	GBB_onAcceptRenameLabel : function(labelName, newLabelName, event) {
    document.getElementById('GBB_bookmark_menupopup').hidePopup();
  	var labelName = labelName;
  	var labelNewName = newLabelName;
    var labelHierarchySeparator = this.gbbPrefs.getCharPref("labelHierarchySeparator");
  	dumpDebug(labelName+labelHierarchySeparator+"\n");
		var affectedLabels = gbb_BookmarkArray.getLabels(labelName);
  	dumpDebug(affectedLabels+"\n");
		if (newLabelName == '')
	    if(!confirm(this.locale_strings.getString('GBB_bookmark_remove_label.confirm_box.before')+" \""+labelName+"\""+this.locale_strings.getString('GBB_bookmark_remove_label.confirm_box.after')))
	  	  return;
 		var refresh = false;
  	var labelNameLength = newLabelName.length == 0 ? labelName.length+1 : labelName.length;
  	for (var i=0; i < affectedLabels.length; i++) {
  		labelNewName = newLabelName+affectedLabels[i].substr(labelNameLength, affectedLabels[i].length);  		
			dumpDebug(i+': '+affectedLabels[i]+" --> "+labelNewName+"\n");
		  dumpDebug(affectedLabels[i]+', '+labelNewName+', '+refresh+"\n");
			GBB.GBB_renameLabelRequest(affectedLabels[i], labelNewName, true);
  	}
   },

	GBB_renameLabelRequest: function(labelName, newLabelName, refresh) {
    GBB.GBB_OverrideUserAgent();
		var req = new XMLHttpRequest();
		var a = labelName;
		var b = newLabelName;
		// Asyncronous connection with the Google Bookmarks server
	  req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
		req.send('op=modlabel&labels='+a+','+b+''); 
		dumpDebug("Sending request to rename label... \n");
		req.onreadystatechange = function(ev)	{
			dumpDebug("Status: "+req.readyState+"\n");
			if(req.readyState == 4) {
				var status = -1;
				try {	status = req.status }
				catch(e) { dumpDebug(e); }
				if(status == 200) {
				  gbb_BookmarkArray.renameLabel(a, b);
					dumpDebug("Label "+a+" renamed to "+b+"! ("+req.status+")\n");						
			    if (refresh)	
						GBB.GBB_onRefresh(false); 
					}
				else{
	        alert("An error occurred while adding the bookmark ("+req.status+")"); }
	    }
	  }
	  GBB.GBB_RestoreUserAgent()
	},  	  
   
	GBB_onImport : function(event) {		
		try { 
			var bkmkService = Components.classes["@mozilla.org/browser/bookmarks-service;1"].getService();
			var xmlBody = "";
			bkmkService.QueryInterface(Components.interfaces.nsIBookmarksService);
			bkmkResources = bkmkService.GetAllResources();

			var i = 0;	  
		 	while (bkmkResources.hasMoreElements()) {
				var urlRes = bkmkResources.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
				var dataParent = RDF.GetDataSource("rdf:bookmarks").getParent(urlRes);

				if (dataParent) {
					var parentName = BookmarksUtils.getProperty(dataParent.Value, "http://home.netscape.com/NC-rdf#Name");
					var parentType = BookmarksUtils.resolveType(dataParent);					
				}
				
				var targetUrl = RDF.GetDataSource("rdf:bookmarks").GetTarget(urlRes, RDF.GetResource("http://home.netscape.com/NC-rdf#URL"), true);
				var targetName = RDF.GetDataSource("rdf:bookmarks").GetTarget(urlRes, RDF.GetResource("http://home.netscape.com/NC-rdf#Name"), true);
				
				if (targetUrl && targetName)	{
					var url = targetUrl.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
					var name = targetName.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;				
					if (parentType == "Folder") {
						i++;
						dumpDebug("+-"+i+" "+escapeHTML(utf8(name))+" ("+escapeHTML(utf8(url))+")"+"\n");
						dumpDebug(" \\--"+i+" "+parentType+" ("+parentName+")"+"\n");
						xmlBody += '<bookmark>'
						xmlBody += '<url>'+escapeHTML(utf8(url))+'</url><title>'+escapeHTML(utf8(name))+'</title>';
						xmlBody += '<labels><label>'+escapeHTML(utf8(parentName))+'</label></labels>'; 
						xmlBody += '</bookmark>';
						}
				}		
			}
		}catch (e) { dumpDebug('!'+e); }
	
		var req = new XMLHttpRequest();
		var xml = '<?xml version="1.0"?><bookmarks>'+xmlBody+'</bookmarks>';
		s = "\r\n"+xml;
		var cLength = parseInt(xml.length);
		h = "Content-length: "+cLength+"\r\nCache-Control: no-cache\r\nContent-Type: application/xml\r\nPragma: no-cache\r\n";

		j = h+s;
		
		dumpDebug(j);

		var obj, a, b, postdata, headerdata;
		
		obj   = Components.classes["@mozilla.org/io/string-input-stream;1"];
		a = Components.interfaces.nsIStringInputStream;
		b = Components.interfaces.nsIStringInputStream;

		postdata = obj.createInstance(a);
		postdata.setData(j, j.length);

		headerdata = obj.createInstance(a);
		headerdata.setData(h, h.length);

		try {
      var nav = getWebNavigation();
      nav.loadURI("http://www.google.com/bookmarks/mark?op=upload", 0, null, postdata, null);
		} catch (e) {
			alert('error!');
		}
 		// Asyncronous connection with the Google Bookmarks server
 		/*
		 req.open("POST", 'http://www.google.com/bookmarks/mark?op=upload', true);
 		req.send(xml);
		dumpDebug("Sending request to import bookmarks... \n");
		req.onreadystatechange = function(ev) {
			dumpDebug("Status: "+req.readyState+"\n");
			if(req.readyState == 4) {
				var status = -1;
				try {	
					status = req.status }
				catch(e) { 
				}
				if(status == 200) {
					window.content.document.write(req.responseText);
					dumpDebug("Text: "+req.getAllResponseHeaders()+"\n");
					dumpDebug("Text: "+req.responseText+"\n");
					dumpDebug("Bookmarks imported! ("+req.status+")\n") }
				else {
          alert("An error occurred while importing the bookmark"); }
      }
    } */ 
	},
	   
	GBB_onSignIn : function(event) {
		var a = window, b=document;
		var c = encodeURIComponent;

		var width = 340;
		var height = 305;
	  var left = Math.floor( (screen.width - width) / 2);
    var top = Math.floor( (screen.height - height) / 2);

		//window.open('https://www.google.com/accounts/ServiceLogin?service=toolbar&nui=1&rm=hide&fpc=1&hl=en&continue=http%3A%2F%2Ftoolbar.google.com%2Fcommand%3Fclose_browser','bkmk_popup','left='+left+',top='+top+',height='+height+'px,width='+width+'px,resizable=1');
		window.open('https://www.google.com/accounts/ServiceLogin?service=toolbar&nui=1&hl=en&continue=http%3A%2F%2Ftoolbar.google.com%2Fcommand%3Fclose_browser','bkmk_popup','left='+left+',top='+top+',height='+height+'px,width='+width+'px,resizable=1');
	},

	GBB_onManageBookmarks : function (event) {
		var url = "http://www.google.com/bookmarks/";		
		event.preventBubble();
		openUILink(url, event, false, true);
		closeMenus(event.target); },

	GBB_onCommandBookmark : function (url, event) {
		var btnCode = event.button;
		var contextMenu = document.getElementById('gbb-bookmarks-context-menu');
		dumpDebug("Button: "+event.button+"\n"); 
		dumpDebug("Button: "+url+"\n"); 		
		if (btnCode == 2)	{                
		  contextMenu.childNodes[0].setAttribute('oncommand', "openUILinkIn('"+url+"', 'current'); document.getElementById('GBB_bookmark_menupopup').hidePopup();");			
		  contextMenu.childNodes[1].setAttribute('oncommand', "openUILinkIn('"+url+"', 'window'); document.getElementById('GBB_bookmark_menupopup').hidePopup();");			
		  contextMenu.childNodes[2].setAttribute('oncommand', "openUILinkIn('"+url+"', 'tab'); document.getElementById('GBB_bookmark_menupopup').hidePopup();");				
		  //contextMenu.childNodes[4].setAttribute('oncommand', "GBB.GBB_onEditBookmark(event, '"+url+"')");			
		  contextMenu.childNodes[4].setAttribute('oncommand', "GBB.GBB_onEditBookmark(event, '"+event.currentTarget.getAttribute('id')+"')");					  
		  contextMenu.childNodes[5].setAttribute('oncommand', "GBB.GBB_onRemoveBookmark('"+event.currentTarget.getAttribute('id')+"')"); }
		else{ 
		 openUILink(url, event, false, true);
		 closeMenus(event.target); }
	},

	GBB_onCommandLabel : function (event) {
		btnCode = event.button;
		var label = event.target.getAttribute('gbb-label');
		var btnCode = event.button;
		dumpDebug("Button: "+event.button+"\n"); 		
		dumpDebug("Target: "+event.target.id+"\n"); 		
	
		switch (btnCode) {
		 case 0:
		   if (event.ctrlKey)
		    GBB.GBB_onOpenInTabs(label, event);
		   break;
		 case 1: 
		    GBB.GBB_onOpenInTabs(label, event);
  		    break;
		 case 2:
		    document.getElementById('gbb-labels-context-menu').childNodes[0].setAttribute('oncommand', "GBB.GBB_onOpenInTabs('"+label+"', event);");			
		    document.getElementById('gbb-labels-context-menu').childNodes[2].setAttribute('oncommand', "GBB.GBB_onOpenRenameLabelDialog('"+label+"', event);");			
		    document.getElementById('gbb-labels-context-menu').childNodes[3].setAttribute('oncommand', "GBB.GBB_onAcceptRenameLabel('"+label+"', '', event);");			
		    break;
		}
	},

	GBB_onOpenInTabs : function (label, event) {
			var labelArray = new Array();
			labelArray = gbb_BookmarkArray.getBookmarksByLabel(label);      
			for (var i = 0; i < labelArray.length; i++)
				openUILinkIn(labelArray[i].url, "tabshifted");
			document.getElementById('GBB_bookmark_menupopup').hidePopup();
	},

	GBB_generateMenuItems : function () {
        // XXX Thanks to Dustin Crockett for the hierarchy code
	//dumpDebug("Made to generate Menu Items\n");
        var orderby = this.gbbPrefs.getCharPref("orderby");
        var enableExperimentalFeatures = this.gbbPrefs.getBoolPref("enableExperimentalFeatures");
        var enableLabelHierarchy = this.gbbPrefs.getBoolPref("enableLabelHierarchy");
        var labelHierarchySeparator = this.gbbPrefs.getCharPref("labelHierarchySeparator");
        var labelsArray = gbb_BookmarkArray.getLabels();
        var gbb_labels = gbb_dom.documentElement.getElementsByTagName('label');
        var s1 = document.createElement('menuseparator');
        var s2 = document.createElement('menuseparator');
    	var r = document.getElementById('GBB_refresh')
        function create_menu(b) {
            var root_menu;
            // XXX To disable the hierarchy use a comma or null as the separator character
            if (enableLabelHierarchy)
							var separator = labelHierarchySeparator;
						else 
							var separator =  ',';
            var parent_label = b.substr(0,b.lastIndexOf(separator));
            //dumpDebug("checking to make sure --"+parent_label+"-- has been created for --"+b+"--\n");
            if ((!document.getElementById('mp_'+parent_label)) && (parent_label != '') && (parent_label != b)) {
                //dumpDebug("Creating_menu "+parent_label+"\n");
                create_menu(parent_label);
                //dumpDebug("created_menu "+parent_label+"\n");
            }
           
            if (parent_label == '' || parent_label == b) {
                root_menu = 'true';
                //dumpDebug("parent is null or equal to b\n");
                var current_label = b;
            } else {
                root_menu = 'false';
                //dumpDebug("parent is not null and not equal to b\n");
                var current_label = b.substr(b.lastIndexOf(separator)+1);
            }           
            //dumpDebug("getting ready to create element\n");
            if (!document.getElementById('mp_'+b)) {
                var m = document.createElement('menu');
                var mp = document.createElement('menupopup');                   
                m.setAttribute('label', unescapeHTML(current_label));
                m.setAttribute('context', 'gbb-labels-context-menu');
                m.setAttribute('container', 'true');
                m.setAttribute('class', 'menu-iconic bookmark-item');
                m.setAttribute('id', 'm_'+b);
                m.setAttribute('gbb-label', b);
                m.setAttribute('onclick', 'GBB.GBB_onCommandLabel(event); event.preventBubble();');
                m.setAttribute('oncommand', 'GBB.GBB_onCommandLabel(event); event.preventBubble();');                                     
                m.setAttribute('onpopupshowing', 'dumpDebug("m_'+b+'"+"\\n")');
                mp.setAttribute('id', 'mp_'+b);
                m.appendChild(mp);
                if (root_menu == 'true') {                   
                    //dumpDebug("Creating menu '"+b+"'\n");
                    document.getElementById('GBB_bookmark_menupopup').insertBefore(m, document.getElementById('GBB_menu_separator_end'));
                    //dumpDebug("inserted element on root\n");
                } else {
                    dumpDebug("getting ready to insert element --mp_"+parent_label+"--\n");
                    document.getElementById('mp_'+parent_label).appendChild(m);   
                    //dumpDebug("inserted element --mp_"+parent_label+"--\n");
                }
            }
               
                //document.getElementById('GBB_bookmark_menupopup').appendChild(m); }
                //document.getElementById('GBB_bookmark_menupopup').insertBefore(m, document.getElementById('GBB_menu_separator_end')); }           
        }
        s1.id = 'GBB_menu_separator';
        s2.id = 'GBB_menu_separator_end';
        document.getElementById('GBB_bookmark_menupopup').insertBefore(s1, r);
        document.getElementById('GBB_bookmark_menupopup').insertBefore(s2, r);

				function sortstr(a,b) {
				    aa = a.toLowerCase();
				    bb = b.toLowerCase();
				    if (aa==bb) return 0;
				    if (aa<bb) return -1;
				    return 1;
				}

        if (orderby == 'title')
            labelsArray.sort(sortstr);

        for (var i=0;i<labelsArray.length;i++) {
            create_menu(labelsArray[i]);                               
        }
    },

	GBB_appendBookmarksToLabel : function () {
	  var orderby = this.gbbPrefs.getCharPref("orderby");
		function sortstr(a,b) {
		    aa = a.title.toLowerCase();
		    bb = b.title.toLowerCase();
		    if (aa==bb) return 0;
		    if (aa<bb) return -1;
		    return 1;
		}
    if (orderby == 'title')
			gbb_BookmarkArray.sort(sortstr);

		for (var i = 0; i < gbb_BookmarkArray.length; i++) {
			var gbb_id = gbb_BookmarkArray[i].id;
			var gbb_url_title = gbb_BookmarkArray[i].title;
			var gbb_url = gbb_BookmarkArray[i].url;
			var gbb_labels = gbb_BookmarkArray[i].labels;
			if (gbb_labels.length != 0)	{			
				for (var j = 0; j < gbb_labels.length; j++)	{  						
					var mi = document.createElement('menuitem');	  				
					b = gbb_labels[j];
					var mp = document.getElementById('mp_'+b);				
					//dumpDebug("|-- "+b+"\n");				
					mi.setAttribute('label', unescapeHTML(gbb_url_title));
					mi.setAttribute('onclick', 'GBB.GBB_onCommandBookmark("'+gbb_url+'", event); event.preventBubble();');
					mi.setAttribute('oncommand', 'GBB.GBB_onCommandBookmark("'+gbb_url+'", event); event.preventBubble();');
					mi.setAttribute('context', 'gbb-bookmarks-context-menu');	
					mi.setAttribute('statustext', gbb_url);	
					mi.setAttribute('tooltiptext', gbb_url);	
					mi.setAttribute('id', gbb_id);
					mi.setAttribute('gbb-url', gbb_url);	                	
				  mi.setAttribute('class','menuitem-iconic bookmark-item');	
				  mi.setAttribute('ondraggesture', 'nsDragAndDrop.startDrag(event,boardObserver)');           	  								
					mp.appendChild(mi);	

					// ### Temporal!!! ###
					if (this.gbbPrefs.getBoolPref("enableExperimentalFeatures") && this.gbbPrefs.getBoolPref("enableFavicons")) {
						var imageURI = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
						var uriLink = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
						uriLink.spec = gbb_url;
						//imageURI.spec = uriLink.scheme + "://" + uriLink.host + "/favicon.ico";
						imageURI.spec = "http://" + uriLink.host + "/favicon.ico";
	
						var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance()
						.QueryInterface(Components.interfaces.nsIURIChecker);
						try { uriChecker.init(imageURI);
									uriChecker.asyncCheck(new faviconURIChecker(imageURI, gbb_id), null);}
						catch (e) { dumpDebug(e); }
					}
					//mi.setAttribute('image', imageUri.spec+'#'+b);	   					  						
				} 
			} else {
					var mi = document.createElement('menuitem');	  											 	  				
					mi.setAttribute('label', gbb_url_title);	
					mi.setAttribute('onclick', 'GBB.GBB_onCommandBookmark("'+gbb_url+'", event);');
					mi.setAttribute('oncommand', 'GBB.GBB_onCommandBookmark("'+gbb_url+'", event); event.preventBubble();');
					mi.setAttribute('context', 'gbb-bookmarks-context-menu');	
					mi.setAttribute('statustext', gbb_url);	
					mi.setAttribute('tooltiptext', gbb_url);	
					mi.setAttribute('id', gbb_id);	
					mi.setAttribute('gbb-url', gbb_url);	
				  mi.setAttribute('class', 'menuitem-iconic bookmark-item');	   					  
				  mi.setAttribute('ondraggesture', 'nsDragAndDrop.startDrag(event,boardObserver)');
					document.getElementById('GBB_bookmark_menupopup').insertBefore(mi, document.getElementById('GBB_menu_separator_end'));

					// ### Temporal!!! ###
					if (this.gbbPrefs.getBoolPref("enableExperimentalFeatures") && this.gbbPrefs.getBoolPref("enableFavicons")) {
						var imageURI = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
						var uriLink = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
						uriLink.spec = gbb_url;
						//imageURI.spec = uriLink.scheme + "://" + uriLink.host + "/favicon.ico";
						imageURI.spec = "http://" + uriLink.host + "/favicon.ico";
	
						var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance()
						.QueryInterface(Components.interfaces.nsIURIChecker);
						try { uriChecker.init(imageURI);
									uriChecker.asyncCheck(new faviconURIChecker(imageURI, gbb_id), null);}
						catch (e) { dumpDebug(e); }			
					}
					//mi.setAttribute('image', imageUri.spec);	   					  						

			}
		}	
	},
	
	GBB_generateBookmarkMenuPopup : function (event) {
			dumpDebug("Menu is set?: "+gbb_menu_isset+"\n");
			if (gbb_dom && !gbb_menu_isset) {
				this.GBB_generateMenuItems();		
				this.GBB_appendBookmarksToLabel();		  	
				gbb_menu_isset = true; }		
	},
	
	GBB_onBookmarkMenuPopup : function (event) {
	  var orderby = this.gbbPrefs.getCharPref("orderby");
		if (event.target.id == 'GBB_bookmark_menupopup') {
	    document.getElementById('GBB_add_to_new_folder').style.display = 'none';    
			if (!gbb_isSigned) {
	      document.getElementById('GBB_bookmark_this_page').style.display = 'none';
	      document.getElementById('GBB_manage_bookmarks').style.display = 'none';
	      document.getElementById('GBB_refresh').style.display = 'none';
	      document.getElementById('GBB_options').style.display = 'none';
	      document.getElementById('GBB_import').style.display = 'none';
	      document.getElementById('GBB_remove_bookmark').style.display = 'none';
	      document.getElementById('GBB_signin').style.display = 'block'; }
			else {
	      document.getElementById('GBB_bookmark_this_page').style.display = 'block';
	      document.getElementById('GBB_manage_bookmarks').style.display = 'block';
	      document.getElementById('GBB_refresh').style.display = 'block';
	      document.getElementById('GBB_import').style.display = 'block';
	      document.getElementById('GBB_options').style.display = 'block';         
	      document.getElementById('GBB_signin').style.display = 'none'; }
	    if (gbb_isSigned != GBB_checkSignedCookie()) {
				GBB.GBB_onRefresh();
				GBB.GBB_getBookmarksFeed(); }
			else if (!gbb_menu_isset) {
				GBB.GBB_getBookmarksFeed();
				this.GBB_generateBookmarkMenuPopup(); }
		}
	},

	GBB_onBookmarkMenuHide : function (event) {
		var target = event.target;
		if (target.id == 'GBB_bookmark_menupopup') {
			var menuitems = target.childNodes;
      for (var i=0; i < menuitems.length; i++) {
        var mi = menuitems[i];
        if(mi.id.indexOf('m_') > -1)
          if (mi.id != target.id){
            mi.childNodes[0].hidePopup();
				}}
		}
	}
}

function GBB_renameLabelDialog() {
 	this.dialogId = null;
 	this.newLabelName = null;
};

GBB_renameLabelDialog.prototype.onOpen = function(label) {
		var url = "chrome://google-bookmarks-button/content/google-bookmarks-rename-label.xul";		
		window.openDialog(url, "gbbOptions", "modal,centerscreen,chrome,resizable=no", label);
		// I don't like how this is done but calling the XMLHttpRequest on dialog.ondialogaccept fails
		// when the dialog is closed because the request variables are deleted
		if (this.newLabelName != null)
			GBB.GBB_onAcceptRenameLabel(label, this.newLabelName);
	};
	
GBB_renameLabelDialog.prototype.onAccept = function(newLabelName, event) {
	 	this.newLabelName = newLabelName;
	};

function GBB_newLabelDialog() {
	 	this.bkmk_url = null;
	 	this.bkmk_title = null;
	 	this.newLabelName = null;
	 	this.notes = null;
};

GBB_newLabelDialog.prototype.onOpen = function(bkmk_url, bkmk_title) {
		var url = "chrome://google-bookmarks-button/content/google-bookmarks-new-label.xul";		
		window.openDialog(url, "gbbOptions", "modal,centerscreen,chrome,resizable=no", bkmk_url, bkmk_title);
		// I don't like how this is done but calling the XMLHttpRequest on dialog.ondialogaccept fails
		// when the dialog is closed because the request variables are deleted
		if (this.newLabelName != null)
   		GBB.GBB_onQuickAddBookmark(null, this.bkmk_title, this.bkmk_url, this.newLabelName+','+gbb_BookmarkArray.getLabelsByUrl(this.bkmk_url), this.notes);	
	};
	
GBB_newLabelDialog.prototype.onAccept = function(bkmk_url, bkmk_title, newLabelName, notes, event) {
	 	this.bkmk_url = bkmk_url;
	 	this.bkmk_title = bkmk_title;
	 	this.newLabelName = newLabelName;		 	 	
	 	this.notes = notes;
	};

function GBB_addBookmarkDialog(action, bkmk_url, bkmk_title, bkmk_notes) {
	 	this.dialog_action = action;
		this.bkmk_url = bkmk_url;
	 	this.bkmk_title = bkmk_title;
	 	if (this.dialog_action == 'edit') {
	 		this.bkmk_labels = gbb_BookmarkArray.getLabelsByUrl(bkmk_url);//null;
			this.bkmk_notes = gbb_BookmarkArray.getNotesByUrl(this.bkmk_url)
		} else {
			this.bkmk_labels = new Array();
			this.bkmk_notes = bkmk_notes;
		}
	 	this.updated = null;
};

GBB_addBookmarkDialog.prototype.onOpen = function() {
		var url = "chrome://google-bookmarks-button/content/google-bookmarks-add-bookmark.xul";		
		window.openDialog(url, "gbbAddBookmarkDialog", "modal,centerscreen,chrome,resizable=no", 
				this.bkmk_url, this.bkmk_title, this.bkmk_labels.join(', '), unescapeHTML(this.bkmk_notes), this.dialog_action);
		// I don't like how this is done but calling the XMLHttpRequest on dialog.ondialogaccept fails
		// when the dialog is closed because the request variables are deleted
 		if (this.updated)
		 GBB.GBB_onQuickAddBookmark(null, this.bkmk_title, this.bkmk_url, this.bkmk_labels, this.bkmk_notes);	
	};
	
GBB_addBookmarkDialog.prototype.onAccept = function(bkmk_url, bkmk_title, bkmk_labels, bkmk_notes, event) {
	 	this.bkmk_url = bkmk_url;
	 	this.bkmk_title = bkmk_title;
	 	this.bkmk_labels = bkmk_labels;
	 	this.bkmk_notes = bkmk_notes;
	 	this.updated = true;
	};
	
function GBB_onOptions(event) {
    var url = "chrome://google-bookmarks-button/content/google-bookmarks-button-settings.xul";		
		event.preventBubble();
    document.getElementById('GBB_bookmark_menupopup').hidePopup();
		window.openDialog(url, "gbbOptions", "modal,centerscreen,chrome,resizable=no");	};


